apiVersion: workspace.devfile.io/v1alpha2
kind: DevWorkspaceTemplate
metadata:
  name: che-idea-nodejs-mongodb
spec:
  commands:
    - id: init-container-command
      apply:
        component: idea-rhel8-injector
  events:
    preStart:
      - init-container-command
  components:
    - name: idea-rhel8
      container:
        image: registry.redhat.io/devspaces/udi-rhel8:3.5
        command:
          - /projector/entrypoint-volume.sh
        env:
          - name: PROJECTOR_ASSEMBLY_DIR
            value: /projector
          - name: PROJECTOR_CONFIG_DIR
            value: /home/user/.jetbrains
        volumeMounts:
          - name: projector-volume
            path: /projector
          - name: projector-configuration
            path: /home/user/.jetbrains
          - name: projector-java-configuration
            path: /home/user/.java
        memoryLimit: 6144Mi
        memoryRequest: 2048Mi
        cpuLimit: 2000m
        cpuRequest: 1500m
        endpoints:
          - name: intellij
            attributes:
              type: main
              cookiesAuthEnabled: true
              discoverable: false
              urlRewriteSupported: true
              secure: false
            targetPort: 8887
            exposure: public
            path: /?backgroundColor=434343&wss
            protocol: http
          - name: intellij-redirect-1
            attributes:
              discoverable: false
              urlRewriteSupported: false
            targetPort: 13131
            exposure: public
            protocol: http
          - name: intellij-redirect-2
            attributes:
              discoverable: false
              urlRewriteSupported: false
            targetPort: 13132
            exposure: public
            protocol: http
          - name: intellij-redirect-3
            attributes:
              discoverable: false
              urlRewriteSupported: false
            targetPort: 13133
            exposure: public
            protocol: http
      attributes:
        app.kubernetes.io/component: idea-rhel8-injector
        app.kubernetes.io/part-of: idea-rhel8.eclipse.org
    - name: projector-volume
      volume: {}
    - name: projector-configuration
      volume: {}
    - name: projector-java-configuration
      volume: {}
    - name: idea-rhel8-injector
      container:
        image: registry.redhat.io/devspaces/idea-rhel8:3.5
        command:
          - /projector/entrypoint-init-container.sh
        env:
          - name: PROJECTOR_VOLUME_MOUNT
            value: /projector-volume
          - name: PROJECTOR_ASSEMBLY_DIR
            value: /projector
        volumeMounts:
          - name: projector-volume
            path: /projector-volume
        memoryLimit: 128Mi
        memoryRequest: 32Mi
        cpuLimit: 500m
        cpuRequest: 30m
---
apiVersion: workspace.devfile.io/v1alpha2
kind: DevWorkspace
metadata:
  name: nodejs-mongodb
spec:
  started: true
  template:
    components:
      - name: nodejs
        container:
          image: registry.redhat.io/devspaces/udi-rhel8:3.5
          env:
            - name: SECRET
              value: 220fd770-c028-480d-8f95-f84353c7d55a
            - name: NODE_ENV
              value: production
          endpoints:
            - exposure: public
              name: nodejs
              targetPort: 8080
          memoryLimit: 1G
          mountSources: true
          volumeMounts:
            - name: npm
              path: /home/user/.npm
        attributes:
          controller.devfile.io/merge-contribution: true
      - name: npm
        volume:
          size: 1G
      - name: mongo
        container:
          image: registry.redhat.io/rhscl/mongodb-36-rhel7:1-50
          env:
            - name: MONGODB_USER
              value: user
            - name: MONGODB_PASSWORD
              value: password
            - name: MONGODB_DATABASE
              value: guestbook
            - name: MONGODB_ADMIN_PASSWORD
              value: password
          endpoints:
            - name: mongodb
              exposure: internal
              targetPort: 27017
          memoryLimit: 512Mi
          mountSources: false
          volumeMounts:
            - name: mongo-storage
              path: /var/lib/mongodb/data
      - name: mongo-storage
        volume:
          size: 1G
    commands:
      - id: 1-run
        exec:
          label: Run the application
          component: nodejs
          workingDir: ${PROJECTS_ROOT}/nodejs-mongodb-sample
          commandLine: npm install && node --inspect=9229 app.js
          group:
            kind: run
    projects:
      - name: nodejs-mongodb-sample
        zip:
          location: '{{ INTERNAL_URL }}/resources/v2/nodejs-mongodb-sample.zip'
  contributions:
    - name: editor
      kubernetes:
        name: che-idea-nodejs-mongodb
